;;; run.scm
;;;
;;; Some tests for srfi-34 egg
;;;

(require-extension srfi-34)

(unless (eq? 'bizarre-exception 
	     (guard ( e [(eq? e 'weird-exception) e]
			[(eq? e 'odd-exception) e]
			[else e])
		    (raise 'bizarre-exception)))
	(error "Failed test 1"))

(unless (eq? 42 
	     (guard (condition
		     ((assq 'a condition) => cdr)
		     ((assq 'b condition)))
		    (raise (list (cons 'a 42)))))
	(error "Failed test 2"))

(unless (equal? (cons 'b 23)
		(guard (condition
			((assq 'a condition) => cdr)
			((assq 'b condition)))
		       (raise (list (cons 'b 23)))))
	(error "Failed test 3"))

(unless (eq? 'an-exception
	     (call-with-current-continuation 
	      (lambda (k)
		(with-exception-handler 
		 (lambda (e) (k e))
		 (lambda ()
		   (raise 'an-exception))))))
	(error "Failed test 4"))

(display "srfi-34 tests succeeded")(newline)